

import { mount } from '@vue/test-utils'
import CLoadingButton from '../CLoadingButton'

const ComponentName = 'CLoadingButton'

let trigger = jest.fn()
//const onChange = () => { trigger() }

const wrapper = mount(CLoadingButton)

const customProps = {
  spinnerType: 'grow',
  progress: true,
  timeout: 3000,
  onChange: trigger,
  spinner: true,
  percent: 15,
}

const customWrapper = mount(CLoadingButton, {
  propsData: customProps,
})

describe(ComponentName, () => {
  it('has a name', () => {
    expect(CLoadingButton.name).toMatch(ComponentName)
  })
  it('renders basic wrapper correctly', () => {
    expect(wrapper.element).toMatchSnapshot()
  })
  it('renders custom wrapper correctly', () => {
    expect(customWrapper.element).toMatchSnapshot()
  })
  it('custom wrapper reaction on click', () => {
    jest.useFakeTimers()
    expect(customWrapper.find('.c-loading-button-spinner').attributes().style).toBe('display: none;')
    customWrapper.find('.btn').trigger('click')
    jest.runAllTimers()
    expect(customWrapper.find('.c-loading-button-spinner').attributes().style).toBe('')
  })
})
